from autolib import * # https://www.ensta-bretagne.fr/automooc/


def draw_omniwheel3D(x):
   mx,my,θ,s1,s2,s3 = list(x[0:8,0])
   B=array([[a, -a/2, -a/2, a, 0],
              [0,a*sqrt(3)/2,-a*sqrt(3)/2,0,0],
              [r, r, r, r,r],
              [ 1, 1, 1, 1, 1]])
   W0=wheel3H(r)
   R1=rot3H(0,0,1)@tran3H(0,0,r)@rot3H(s1,0,0)
   Rb=tran3H(mx,my,0)@rot3H(0,0,θ)
   draw3H(ax,Rb@B,'black')
   draw3H(ax,R1@W0,'red',True)
          
ax=figure3D()
r,a,dt = 1,3,0.01
x   = array([[0],[0],[0],[0],[0],[0]]) # x=(x,y,θ,s1,s2,s3)
for t in arange(0,1,dt) : 
    clean3D(ax,-4,4,-4,4,-1,7)
    mx,my,θ,s1,s2,s3 = list(x[0:6,0])
    A=(1/r)*array([[sin(θ),-cos(θ),-a],  
       [sin(θ+2*pi/3),-cos(θ+2*pi/3),-a],
        [sin(θ-2*pi/3),-cos(θ-2*pi/3),-a]])
    x=x+dt*array([[1],[0],[1],[2],[0],[0]])
    draw_omniwheel3D(x)
    pause(0.01)
    
pause(1)    

  
  
